package com.tfg.portatil10.controlPorta;

import android.content.Intent;
import android.support.v7.app.AppCompatActivity;
import android.os.Bundle;
import android.util.Log;
import android.view.View;
import android.widget.TextView;

import org.json.JSONException;
import org.json.JSONObject;
import java.io.IOException;
import java.util.Timer;
import java.util.TimerTask;


public class MainActivity extends AppCompatActivity implements AsyncResponse {
    private static final String TAG = MainActivity.class.getSimpleName();
    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_main);
        Intent intent = getIntent();
        Bundle extras = intent.getExtras();
        try {
            String estat = extras.getString("accio");
            if (estat != null) {
                if (estat.compareTo("obrir") == 0) {
                    execAccio("obrir");
                } else if (estat.compareTo("tancar") == 0) {
                    execAccio("tancar");
                } else if (estat.compareTo("aturar") == 0) {
                    execAccio("aturar");
                }
            }
        }catch(Exception e) {
        Log.e("intent:", " " + e);
     }
        Timer timerObj = new Timer();
        TimerTask timerTaskObj = new TimerTask() {
            public void run() {
                execAccio("");
            }
        };
        timerObj.schedule(timerTaskObj, 0, 3000);
    }

    public void obrir(View view) {
        execAccio("obrir");
}
    public void tancar(View view) throws IOException, JSONException {
        execAccio("tancar");
    }
    public void aturar(View view) throws IOException, JSONException {
        execAccio("aturar");
    }

    public void execAccio (String accio){
        String url=leerConf("url");
        String password=leerConf("password");
        new Utilitats.GetDataSync(this).execute(accio,url,password);
    }

    public void actualitzarEstat(JSONObject json) throws JSONException {
        TextView tEstat = (TextView) findViewById(R.id.tEstat);
        TextView tIR = (TextView) findViewById(R.id.tIR);
        String motor =  json.getString("motor");
        String pObert =  json.getString("pObert");
        String pTancat =  json.getString("pTancat");
        int ir;
        int intEstat;
        try {
             ir = Integer.parseInt(json.getString("ir"));
             intEstat = Integer.parseInt(motor + pObert + pTancat);
        }catch (Exception e){
             ir = Integer.parseInt("0");
             intEstat = Integer.parseInt("000");
        }

        String estat="";
        switch (intEstat) {
            case 000:
                estat = "Aturada";
                break;
            case 100:
                estat = "Obrint";
                break;
            case 200:
                estat = "Tancant";
                break;
            case 10:
                estat = "Oberta";
                break;
            case 001:
                estat = "Tancada";
                break;
        }
        Log.e(TAG, "Estat:  " + estat);
        Log.e(TAG, "intEstat:  " + intEstat);
        if (ir!=0){
            tIR.setText("Obstacle");
        }else{
            tIR.setText("Lliure");
        }
        tEstat.setText(estat);
    }

    private String leerConf(String arxiu){

        return Utilitats.getFile(this,arxiu);
    }

    public void configurar(View view){
        Intent intent = new Intent(this, configuracio.class);
        startActivity(intent);
    }

}
