
/*
 * Control de la porta d'access a la finca
 */
 
//Definició d'estats
const int ATURAT=0;
const int OBRINT=1;
const int TANCANT=2;

//Definició de pins
const int mObrir=4;
const int mTanacar=5;
const int pOberta=7;
const int pTancada=8;

//Definició d'Accions
const int aturar=1;
const int obrir=2;
const int tancar=3;


//Definició de variables
int estat=ATURAT;
int accio;
int IR=0;
int mO;
int mT;
int pO=LOW;
int pT=LOW;
int sRead ;


void setup()
{
  pinMode (mObrir, OUTPUT);    // Motor obrir
  pinMode (mTanacar, OUTPUT);  // Motor tancar
  pinMode (pOberta, INPUT);    // Polsador Porta Oberta
  pinMode (pTancada, INPUT);   // Polsador Porta Tancada
  
  Serial.begin(9600);
  
  attachInterrupt(0,polsadorInt, CHANGE);
  attachInterrupt(1,irInt, CHANGE);
}
void loop()
{
  
  int enviaEstat=0;
  
  sRead=Serial.parseInt();
  if (sRead<4 && sRead>=1){
    accio=sRead;
  } else if (sRead==4) {
    enviaEstat=1;
  } 
//Serial.println(sRead);
//Serial.println(accio);
// Tractament dels estats segons la definició feta al disseny de la màquina d'estats
  switch(estat){ 
    case ATURAT: 
            mO=LOW;
            mT=LOW;
            actMotors();
            //delay(500);
            if (accio==tancar && IR==0 && pT==LOW) {estat=TANCANT;}
            if (accio==obrir && IR==0 && pO==LOW) {estat=OBRINT;} 
            if (!(accio==obrir && IR==0 && pO==LOW)&& !(accio==tancar && IR==0 && pT==LOW)) {estat=ATURAT;} 
           // debug();
            break;
    case OBRINT: 
            mO=HIGH;
            mT=LOW;
            actMotors();
            if (accio==obrir && IR==0 && pO==LOW) {estat=OBRINT;} 
            if (!(accio==obrir && IR==0 && pO==LOW)) {estat=ATURAT;} 
           // debug();
            break;          
    case TANCANT: 
            mO=LOW;
            mT=HIGH;
            actMotors();
            if (accio==tancar && IR==0 && pT==LOW) {estat=TANCANT;}
            if (!(accio==tancar && IR==0 && pT==LOW)) {estat=ATURAT;} 
           // debug();
            break;   
  }

  if (enviaEstat==1) {actEstatEnv();}
  enviaEstat=0;
}

//Tractament de la interrupció dels polsadors
void polsadorInt() 
{
  pO=digitalRead(pOberta);
  pT=digitalRead(pTancada);
  if (accio==obrir){
      if (pO==1) {accio=aturar;}
  }
  if (accio==tancar){
      if (pT==1) {accio=aturar;}
  }
 }

// Tractament de la interrupció de IR
void irInt() //
{
     IR=!digitalRead(3);
     accio=aturar;
 }

/*
 * Escriptura de l'estat al serial. Només s'escriu si s'ha rebut una ordre pel port serie
 */
void actEstatEnv(){ 
  Serial.println(estat);
  Serial.println(pO);
  Serial.println(pT);
  Serial.println(IR);
}
/*   
 *    Configuració del gir del motor
 */
void actMotors(){
  digitalWrite (mObrir, mO);
  digitalWrite (mTanacar, mT); 
}

void debug(){
  Serial.print("estat=");
  Serial.println(estat);
  Serial.print("pO=");
  Serial.println(pO);
  Serial.print("pT=");
  Serial.println(pT);
  Serial.print("IR=");
  Serial.println(IR);
}




